﻿Imports Bricscad.ApplicationServices
Imports Teigha.DatabaseServices
Imports Teigha.Geometry
Imports Teigha.Runtime

Public Module TEST
    <CommandMethod("TEST")>
    Public Sub BlockTest()
        Try
            Dim doc As Document = Application.DocumentManager.MdiActiveDocument
            Dim db As Database = doc.Database
            Using tr As Transaction = db.TransactionManager.StartTransaction
                Dim blkName As String = DateAndTime.Timer.ToString.Replace(".", "")
                Dim ptIns As Point3d = Point3d.Origin
                Dim blkbtr As New BlockTableRecord With {
                    .Name = blkName,
                    .Origin = ptIns
                }

                Dim poly As New Polyline
                With poly
                    .AddVertexAt(0, New Point2d(0, 0), 0, 0, 0)
                    .AddVertexAt(1, New Point2d(5, 0), 0, 0, 0)
                    .AddVertexAt(2, New Point2d(5, 5), 0, 0, 0)
                    .AddVertexAt(3, New Point2d(0, 5), 0, 0, 0)
                    .Closed = True
                End With
                blkbtr.AppendEntity(poly)

                Dim pt As New Point3d(2.5, 2.5, 0)
                Dim txt As New DBText
                With txt
                    .SetDatabaseDefaults()
                    .Position = pt
                    .Height = 2
                    .TextString = "A"
                    .VerticalMode = TextVerticalMode.TextVerticalMid
                    .HorizontalMode = TextHorizontalMode.TextCenter
                    .AlignmentPoint = pt
                End With
                blkbtr.AppendEntity(txt) 'System.NullReferenceException in TD_Mgd.dll

                Dim bt As BlockTable = DirectCast(tr.GetObject(db.BlockTableId, OpenMode.ForWrite), BlockTable)
                Dim btr As BlockTableRecord = CType(tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite), BlockTableRecord)
                bt.Add(blkbtr)
                tr.AddNewlyCreatedDBObject(blkbtr, True)

                Dim blkRef As New BlockReference(ptIns, blkbtr.ObjectId)
                btr.AppendEntity(blkRef)
                tr.AddNewlyCreatedDBObject(blkRef, True)

                tr.Commit()
            End Using
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Information)
        End Try
    End Sub
End Module